/*
Scrivere un programma in linguaggio C che legge da un file di testo tre indirizzi MAC e ne determini il tipo: single, multicast o broadcast.
*/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "htoi.inc"  // funzione htoi()

#define NUMMAC 3  // quanti indirizzi MAC si analizzano
#define DIMMAC 20 // n. caratteri per un indirizzo MAC
#define IGMASK (0x01)  //01h = 00000001b
#define ULMASK (0x02)  //02h = 00000010b

int main (void)
{
  FILE *fp;
  int i,j;
  char *asz[NUMMAC]; // un elemento per indirizzo MAC
  unsigned char bytMac;
  char szByte[3]; char szMsg[80];

  fp = fopen ("macaddr.txt", "r");
  for (i = 0; i < NUMMAC; i++)
  {
    char *pc;
    pc = (char *)malloc(DIMMAC);
    if (fgets (pc, 100, fp) == NULL ) return 1;
    *(pc+strlen(pc)-1) = 0;  // via il \n
    asz[i] = pc;
  }
  fclose (fp);

  for (i = 0; i < NUMMAC; i++)
  {
    // il primo byte dell'indirizzo MAC
    szByte[0]=asz[i][0]; szByte[1]=asz[i][1]; szByte[2]=0;
    bytMac = (unsigned char) htoi(szByte);

    if ((IGMASK & bytMac) == IGMASK)
    {
      int f = 1;

      for (j=0;j<6;j++)
      {
        if (asz[i][j*3]!=asz[i][j*3+1])
        {
          f = 0;
          break;
        }
      }

      if ((f) && (asz[i][0]=='f'))
      {
        strcpy(szMsg,"broadcast");
      }
      else
      {
        strcpy(szMsg,"multicast");
        if ((ULMASK & bytMac) == ULMASK)
          strcat(szMsg," local"); else strcat(szMsg,"/universal");
      }
    }
    else
    {
      strcpy(szMsg,"single");
    }

    printf("\nIndirizzo MAC %d: %s, %s",i, asz[i], szMsg);

  }

  return 0;
}



